﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Core.Networks;
using HeuristicLab.Data;

namespace HeuristicLab.Networks.IntegratedOptimization {
  public abstract class ActionMessage : Message {
    private const string SenderValueName = "Sender";
    private const string ActionValueName = "Action";

    public IMessagePort Sender {
      get { return (IMessagePort)this[SenderValueName]; }
    }

    public MessageAction Action {
      get { return ((EnumValue<MessageAction>)this[ActionValueName]).Value; }
    }

    public ActionMessage(IMessagePort sender, MessageAction action) {
      values.Add(new MessageValue<IMessagePort>(SenderValueName, sender));
      values.Add(new MessageValue<EnumValue<MessageAction>>(ActionValueName, new EnumValue<MessageAction>(action)));
    }
  }
}
