﻿using System.Threading.Tasks;
using HeuristicLab.Core;
using HeuristicLab.Core.Networks;
using HeuristicLab.Optimization;

namespace HeuristicLab.Networks.IntegratedOptimization {
  public interface IOrchestratorNode : INode {
    IKeyedItemCollection<string, IParameter> Parameters { get; }
    ResultCollection Results { get; }

    void Prepare();
    Task PrepareAsync();
    void Start();
    Task StartAsync();
    void Pause();
    Task PauseAsync();
    void Stop();
    Task StopAsync();
  }
}
